// $Id: License.cpp,v 1.14 2008-05-04 08:31:11 geuzaine Exp $
//
// Copyright (C) 1997-2008 C. Geuzaine, J.-F. Remacle
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
// USA.
// 
// Please report all bugs and problems to <gmsh@geuz.org>.

#include "Message.h"

void print_license(void)
{
  Msg::Direct("Gmsh is provided under the terms of the GNU General Public License");
  Msg::Direct("(GPL) with the following exception:");
  Msg::Direct(" ");
  Msg::Direct("  The copyright holders of Gmsh give you permission to combine Gmsh");
  Msg::Direct("  with code included in the standard release of Triangle (written by");
  Msg::Direct("  Jonathan Shewchuk), TetGen (written by Hang Si) and Netgen (written");
  Msg::Direct("  by Joachim Schoberl) under their respective licenses. You may copy");
  Msg::Direct("  and distribute such a system following the terms of the GNU GPL for");
  Msg::Direct("  Gmsh and the licenses of the other code concerned, provided that you");
  Msg::Direct("  include the source code of that other code when and as the GNU GPL");
  Msg::Direct("  requires distribution of source code.");
  Msg::Direct(" ");
  Msg::Direct("  Note that people who make modified versions of Gmsh are not");
  Msg::Direct("  obligated to grant this special exception for their modified");
  Msg::Direct("  versions; it is their choice whether to do so. The GNU General");
  Msg::Direct("  Public License gives permission to release a modified version");
  Msg::Direct("  without this exception; this exception also makes it possible to");
  Msg::Direct("  release a modified version which carries forward this exception.");
  Msg::Direct(" ");
  Msg::Direct("End of exception.");
  Msg::Direct(" ");
  Msg::Direct("             GNU GENERAL PUBLIC LICENSE");
  Msg::Direct("                Version 2, June 1991");
  Msg::Direct(" ");
  Msg::Direct(" Copyright (C) 1989, 1991 Free Software Foundation, Inc.");
  Msg::Direct(" 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA");
  Msg::Direct(" Everyone is permitted to copy and distribute verbatim copies");
  Msg::Direct(" of this license document, but changing it is not allowed.");
  Msg::Direct(" ");
  Msg::Direct("                     Preamble");
  Msg::Direct(" ");
  Msg::Direct("  The licenses for most software are designed to take away your");
  Msg::Direct("freedom to share and change it.  By contrast, the GNU General Public");
  Msg::Direct("License is intended to guarantee your freedom to share and change free");
  Msg::Direct("software--to make sure the software is free for all its users.  This");
  Msg::Direct("General Public License applies to most of the Free Software");
  Msg::Direct("Foundation's software and to any other program whose authors commit to");
  Msg::Direct("using it.  (Some other Free Software Foundation software is covered by");
  Msg::Direct("the GNU Library General Public License instead.)  You can apply it to");
  Msg::Direct("your programs, too.");
  Msg::Direct(" ");
  Msg::Direct("  When we speak of free software, we are referring to freedom, not");
  Msg::Direct("price.  Our General Public Licenses are designed to make sure that you");
  Msg::Direct("have the freedom to distribute copies of free software (and charge for");
  Msg::Direct("this service if you wish), that you receive source code or can get it");
  Msg::Direct("if you want it, that you can change the software or use pieces of it");
  Msg::Direct("in new free programs; and that you know you can do these things.");
  Msg::Direct(" ");
  Msg::Direct("  To protect your rights, we need to make restrictions that forbid");
  Msg::Direct("anyone to deny you these rights or to ask you to surrender the rights.");
  Msg::Direct("These restrictions translate to certain responsibilities for you if you");
  Msg::Direct("distribute copies of the software, or if you modify it.");
  Msg::Direct(" ");
  Msg::Direct("  For example, if you distribute copies of such a program, whether");
  Msg::Direct("gratis or for a fee, you must give the recipients all the rights that");
  Msg::Direct("you have.  You must make sure that they, too, receive or can get the");
  Msg::Direct("source code.  And you must show them these terms so they know their");
  Msg::Direct("rights.");
  Msg::Direct(" ");
  Msg::Direct("  We protect your rights with two steps: (1) copyright the software, and");
  Msg::Direct("(2) offer you this license which gives you legal permission to copy,");
  Msg::Direct("distribute and/or modify the software.");
  Msg::Direct(" ");
  Msg::Direct("  Also, for each author's protection and ours, we want to make certain");
  Msg::Direct("that everyone understands that there is no warranty for this free");
  Msg::Direct("software.  If the software is modified by someone else and passed on, we");
  Msg::Direct("want its recipients to know that what they have is not the original, so");
  Msg::Direct("that any problems introduced by others will not reflect on the original");
  Msg::Direct("authors' reputations.");
  Msg::Direct(" ");
  Msg::Direct("  Finally, any free program is threatened constantly by software");
  Msg::Direct("patents.  We wish to avoid the danger that redistributors of a free");
  Msg::Direct("program will individually obtain patent licenses, in effect making the");
  Msg::Direct("program proprietary.  To prevent this, we have made it clear that any");
  Msg::Direct("patent must be licensed for everyone's free use or not licensed at all.");
  Msg::Direct(" ");
  Msg::Direct("  The precise terms and conditions for copying, distribution and");
  Msg::Direct("modification follow.");
  Msg::Direct(" ");
  Msg::Direct("             GNU GENERAL PUBLIC LICENSE");
  Msg::Direct("   TERMS AND CONDITIONS FOR COPYING, DISTRIBUTION AND MODIFICATION");
  Msg::Direct(" ");
  Msg::Direct("  0. This License applies to any program or other work which contains");
  Msg::Direct("a notice placed by the copyright holder saying it may be distributed");
  Msg::Direct("under the terms of this General Public License.  The \"Program\", below,");
  Msg::Direct("refers to any such program or work, and a \"work based on the Program\" ");
  Msg::Direct("means either the Program or any derivative work under copyright law:");
  Msg::Direct("that is to say, a work containing the Program or a portion of it,");
  Msg::Direct("either verbatim or with modifications and/or translated into another");
  Msg::Direct("language.  (Hereinafter, translation is included without limitation in");
  Msg::Direct("the term \"modification\".)  Each licensee is addressed as \"you\".");
  Msg::Direct(" ");
  Msg::Direct("Activities other than copying, distribution and modification are not");
  Msg::Direct("covered by this License; they are outside its scope.  The act of");
  Msg::Direct("running the Program is not restricted, and the output from the Program");
  Msg::Direct("is covered only if its contents constitute a work based on the");
  Msg::Direct("Program (independent of having been made by running the Program).");
  Msg::Direct("Whether that is true depends on what the Program does.");
  Msg::Direct(" ");
  Msg::Direct("  1. You may copy and distribute verbatim copies of the Program's");
  Msg::Direct("source code as you receive it, in any medium, provided that you");
  Msg::Direct("conspicuously and appropriately publish on each copy an appropriate");
  Msg::Direct("copyright notice and disclaimer of warranty; keep intact all the");
  Msg::Direct("notices that refer to this License and to the absence of any warranty;");
  Msg::Direct("and give any other recipients of the Program a copy of this License");
  Msg::Direct("along with the Program.");
  Msg::Direct(" ");
  Msg::Direct("You may charge a fee for the physical act of transferring a copy, and");
  Msg::Direct("you may at your option offer warranty protection in exchange for a fee.");
  Msg::Direct(" ");
  Msg::Direct("  2. You may modify your copy or copies of the Program or any portion");
  Msg::Direct("of it, thus forming a work based on the Program, and copy and");
  Msg::Direct("distribute such modifications or work under the terms of Section 1");
  Msg::Direct("above, provided that you also meet all of these conditions:");
  Msg::Direct(" ");
  Msg::Direct("    a) You must cause the modified files to carry prominent notices");
  Msg::Direct("    stating that you changed the files and the date of any change.");
  Msg::Direct(" ");
  Msg::Direct("    b) You must cause any work that you distribute or publish, that in");
  Msg::Direct("    whole or in part contains or is derived from the Program or any");
  Msg::Direct("    part thereof, to be licensed as a whole at no charge to all third");
  Msg::Direct("    parties under the terms of this License.");
  Msg::Direct(" ");
  Msg::Direct("    c) If the modified program normally reads commands interactively");
  Msg::Direct("    when run, you must cause it, when started running for such");
  Msg::Direct("    interactive use in the most ordinary way, to print or display an");
  Msg::Direct("    announcement including an appropriate copyright notice and a");
  Msg::Direct("    notice that there is no warranty (or else, saying that you provide");
  Msg::Direct("    a warranty) and that users may redistribute the program under");
  Msg::Direct("    these conditions, and telling the user how to view a copy of this");
  Msg::Direct("    License.  (Exception: if the Program itself is interactive but");
  Msg::Direct("    does not normally print such an announcement, your work based on");
  Msg::Direct("    the Program is not required to print an announcement.)");
  Msg::Direct(" ");
  Msg::Direct("These requirements apply to the modified work as a whole.  If");
  Msg::Direct("identifiable sections of that work are not derived from the Program,");
  Msg::Direct("and can be reasonably considered independent and separate works in");
  Msg::Direct("themselves, then this License, and its terms, do not apply to those");
  Msg::Direct("sections when you distribute them as separate works.  But when you");
  Msg::Direct("distribute the same sections as part of a whole which is a work based");
  Msg::Direct("on the Program, the distribution of the whole must be on the terms of");
  Msg::Direct("this License, whose permissions for other licensees extend to the");
  Msg::Direct("entire whole, and thus to each and every part regardless of who wrote it.");
  Msg::Direct(" ");
  Msg::Direct("Thus, it is not the intent of this section to claim rights or contest");
  Msg::Direct("your rights to work written entirely by you; rather, the intent is to");
  Msg::Direct("exercise the right to control the distribution of derivative or");
  Msg::Direct("collective works based on the Program.");
  Msg::Direct(" ");
  Msg::Direct("In addition, mere aggregation of another work not based on the Program");
  Msg::Direct("with the Program (or with a work based on the Program) on a volume of");
  Msg::Direct("a storage or distribution medium does not bring the other work under");
  Msg::Direct("the scope of this License.");
  Msg::Direct(" ");
  Msg::Direct("  3. You may copy and distribute the Program (or a work based on it,");
  Msg::Direct("under Section 2) in object code or executable form under the terms of");
  Msg::Direct("Sections 1 and 2 above provided that you also do one of the following:");
  Msg::Direct(" ");
  Msg::Direct("    a) Accompany it with the complete corresponding machine-readable");
  Msg::Direct("    source code, which must be distributed under the terms of Sections");
  Msg::Direct("    1 and 2 above on a medium customarily used for software interchange; or,");
  Msg::Direct(" ");
  Msg::Direct("    b) Accompany it with a written offer, valid for at least three");
  Msg::Direct("    years, to give any third party, for a charge no more than your");
  Msg::Direct("    cost of physically performing source distribution, a complete");
  Msg::Direct("    machine-readable copy of the corresponding source code, to be");
  Msg::Direct("    distributed under the terms of Sections 1 and 2 above on a medium");
  Msg::Direct("    customarily used for software interchange; or,");
  Msg::Direct(" ");
  Msg::Direct("    c) Accompany it with the information you received as to the offer");
  Msg::Direct("    to distribute corresponding source code.  (This alternative is");
  Msg::Direct("    allowed only for noncommercial distribution and only if you");
  Msg::Direct("    received the program in object code or executable form with such");
  Msg::Direct("    an offer, in accord with Subsection b above.)");
  Msg::Direct(" ");
  Msg::Direct("The source code for a work means the preferred form of the work for");
  Msg::Direct("making modifications to it.  For an executable work, complete source");
  Msg::Direct("code means all the source code for all modules it contains, plus any");
  Msg::Direct("associated interface definition files, plus the scripts used to");
  Msg::Direct("control compilation and installation of the executable.  However, as a");
  Msg::Direct("special exception, the source code distributed need not include");
  Msg::Direct("anything that is normally distributed (in either source or binary");
  Msg::Direct("form) with the major components (compiler, kernel, and so on) of the");
  Msg::Direct("operating system on which the executable runs, unless that component");
  Msg::Direct("itself accompanies the executable.");
  Msg::Direct(" ");
  Msg::Direct("If distribution of executable or object code is made by offering");
  Msg::Direct("access to copy from a designated place, then offering equivalent");
  Msg::Direct("access to copy the source code from the same place counts as");
  Msg::Direct("distribution of the source code, even though third parties are not");
  Msg::Direct("compelled to copy the source along with the object code.");
  Msg::Direct(" ");
  Msg::Direct("  4. You may not copy, modify, sublicense, or distribute the Program");
  Msg::Direct("except as expressly provided under this License.  Any attempt");
  Msg::Direct("otherwise to copy, modify, sublicense or distribute the Program is");
  Msg::Direct("void, and will automatically terminate your rights under this License.");
  Msg::Direct("However, parties who have received copies, or rights, from you under");
  Msg::Direct("this License will not have their licenses terminated so long as such");
  Msg::Direct("parties remain in full compliance.");
  Msg::Direct(" ");
  Msg::Direct("  5. You are not required to accept this License, since you have not");
  Msg::Direct("signed it.  However, nothing else grants you permission to modify or");
  Msg::Direct("distribute the Program or its derivative works.  These actions are");
  Msg::Direct("prohibited by law if you do not accept this License.  Therefore, by");
  Msg::Direct("modifying or distributing the Program (or any work based on the");
  Msg::Direct("Program), you indicate your acceptance of this License to do so, and");
  Msg::Direct("all its terms and conditions for copying, distributing or modifying");
  Msg::Direct("the Program or works based on it.");
  Msg::Direct(" ");
  Msg::Direct("  6. Each time you redistribute the Program (or any work based on the");
  Msg::Direct("Program), the recipient automatically receives a license from the");
  Msg::Direct("original licensor to copy, distribute or modify the Program subject to");
  Msg::Direct("these terms and conditions.  You may not impose any further");
  Msg::Direct("restrictions on the recipients' exercise of the rights granted herein.");
  Msg::Direct("You are not responsible for enforcing compliance by third parties to");
  Msg::Direct("this License.");
  Msg::Direct(" ");
  Msg::Direct("  7. If, as a consequence of a court judgment or allegation of patent");
  Msg::Direct("infringement or for any other reason (not limited to patent issues),");
  Msg::Direct("conditions are imposed on you (whether by court order, agreement or");
  Msg::Direct("otherwise) that contradict the conditions of this License, they do not");
  Msg::Direct("excuse you from the conditions of this License.  If you cannot");
  Msg::Direct("distribute so as to satisfy simultaneously your obligations under this");
  Msg::Direct("License and any other pertinent obligations, then as a consequence you");
  Msg::Direct("may not distribute the Program at all.  For example, if a patent");
  Msg::Direct("license would not permit royalty-free redistribution of the Program by");
  Msg::Direct("all those who receive copies directly or indirectly through you, then");
  Msg::Direct("the only way you could satisfy both it and this License would be to");
  Msg::Direct("refrain entirely from distribution of the Program.");
  Msg::Direct(" ");
  Msg::Direct("If any portion of this section is held invalid or unenforceable under");
  Msg::Direct("any particular circumstance, the balance of the section is intended to");
  Msg::Direct("apply and the section as a whole is intended to apply in other");
  Msg::Direct("circumstances.");
  Msg::Direct(" ");
  Msg::Direct("It is not the purpose of this section to induce you to infringe any");
  Msg::Direct("patents or other property right claims or to contest validity of any");
  Msg::Direct("such claims; this section has the sole purpose of protecting the");
  Msg::Direct("integrity of the free software distribution system, which is");
  Msg::Direct("implemented by public license practices.  Many people have made");
  Msg::Direct("generous contributions to the wide range of software distributed");
  Msg::Direct("through that system in reliance on consistent application of that");
  Msg::Direct("system; it is up to the author/donor to decide if he or she is willing");
  Msg::Direct("to distribute software through any other system and a licensee cannot");
  Msg::Direct("impose that choice.");
  Msg::Direct(" ");
  Msg::Direct("This section is intended to make thoroughly clear what is believed to");
  Msg::Direct("be a consequence of the rest of this License.");
  Msg::Direct(" ");
  Msg::Direct("  8. If the distribution and/or use of the Program is restricted in");
  Msg::Direct("certain countries either by patents or by copyrighted interfaces, the");
  Msg::Direct("original copyright holder who places the Program under this License");
  Msg::Direct("may add an explicit geographical distribution limitation excluding");
  Msg::Direct("those countries, so that distribution is permitted only in or among");
  Msg::Direct("countries not thus excluded.  In such case, this License incorporates");
  Msg::Direct("the limitation as if written in the body of this License.");
  Msg::Direct(" ");
  Msg::Direct("  9. The Free Software Foundation may publish revised and/or new versions");
  Msg::Direct("of the General Public License from time to time.  Such new versions will");
  Msg::Direct("be similar in spirit to the present version, but may differ in detail to");
  Msg::Direct("address new problems or concerns.");
  Msg::Direct(" ");
  Msg::Direct("Each version is given a distinguishing version number.  If the Program");
  Msg::Direct("specifies a version number of this License which applies to it and \"any");
  Msg::Direct("later version\", you have the option of following the terms and conditions");
  Msg::Direct("either of that version or of any later version published by the Free");
  Msg::Direct("Software Foundation.  If the Program does not specify a version number of");
  Msg::Direct("this License, you may choose any version ever published by the Free Software");
  Msg::Direct("Foundation.");
  Msg::Direct(" ");
  Msg::Direct("  10. If you wish to incorporate parts of the Program into other free");
  Msg::Direct("programs whose distribution conditions are different, write to the author");
  Msg::Direct("to ask for permission.  For software which is copyrighted by the Free");
  Msg::Direct("Software Foundation, write to the Free Software Foundation; we sometimes");
  Msg::Direct("make exceptions for this.  Our decision will be guided by the two goals");
  Msg::Direct("of preserving the free status of all derivatives of our free software and");
  Msg::Direct("of promoting the sharing and reuse of software generally.");
  Msg::Direct(" ");
  Msg::Direct("                     NO WARRANTY");
  Msg::Direct(" ");
  Msg::Direct("  11. BECAUSE THE PROGRAM IS LICENSED FREE OF CHARGE, THERE IS NO WARRANTY");
  Msg::Direct("FOR THE PROGRAM, TO THE EXTENT PERMITTED BY APPLICABLE LAW.  EXCEPT WHEN");
  Msg::Direct("OTHERWISE STATED IN WRITING THE COPYRIGHT HOLDERS AND/OR OTHER PARTIES");
  Msg::Direct("PROVIDE THE PROGRAM \"AS IS\" WITHOUT WARRANTY OF ANY KIND, EITHER EXPRESSED");
  Msg::Direct("OR IMPLIED, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF");
  Msg::Direct("MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.  THE ENTIRE RISK AS");
  Msg::Direct("TO THE QUALITY AND PERFORMANCE OF THE PROGRAM IS WITH YOU.  SHOULD THE");
  Msg::Direct("PROGRAM PROVE DEFECTIVE, YOU ASSUME THE COST OF ALL NECESSARY SERVICING,");
  Msg::Direct("REPAIR OR CORRECTION.");
  Msg::Direct(" ");
  Msg::Direct("  12. IN NO EVENT UNLESS REQUIRED BY APPLICABLE LAW OR AGREED TO IN WRITING");
  Msg::Direct("WILL ANY COPYRIGHT HOLDER, OR ANY OTHER PARTY WHO MAY MODIFY AND/OR");
  Msg::Direct("REDISTRIBUTE THE PROGRAM AS PERMITTED ABOVE, BE LIABLE TO YOU FOR DAMAGES,");
  Msg::Direct("INCLUDING ANY GENERAL, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES ARISING");
  Msg::Direct("OUT OF THE USE OR INABILITY TO USE THE PROGRAM (INCLUDING BUT NOT LIMITED");
  Msg::Direct("TO LOSS OF DATA OR DATA BEING RENDERED INACCURATE OR LOSSES SUSTAINED BY");
  Msg::Direct("YOU OR THIRD PARTIES OR A FAILURE OF THE PROGRAM TO OPERATE WITH ANY OTHER");
  Msg::Direct("PROGRAMS), EVEN IF SUCH HOLDER OR OTHER PARTY HAS BEEN ADVISED OF THE");
  Msg::Direct("POSSIBILITY OF SUCH DAMAGES.");
  Msg::Direct(" ");
  Msg::Direct("              END OF TERMS AND CONDITIONS");
  Msg::Direct(" ");
  Msg::Direct("     How to Apply These Terms to Your New Programs");
  Msg::Direct(" ");
  Msg::Direct("  If you develop a new program, and you want it to be of the greatest");
  Msg::Direct("possible use to the public, the best way to achieve this is to make it");
  Msg::Direct("free software which everyone can redistribute and change under these terms.");
  Msg::Direct(" ");
  Msg::Direct("  To do so, attach the following notices to the program.  It is safest");
  Msg::Direct("to attach them to the start of each source file to most effectively");
  Msg::Direct("convey the exclusion of warranty; and each file should have at least");
  Msg::Direct("the \"copyright\" line and a pointer to where the full notice is found.");
  Msg::Direct(" ");
  Msg::Direct("    <one line to give the program's name and a brief idea of what it does.>");
  Msg::Direct("    Copyright (C) <year>  <name of author>");
  Msg::Direct(" ");
  Msg::Direct("    This program is free software; you can redistribute it and/or modify");
  Msg::Direct("    it under the terms of the GNU General Public License as published by");
  Msg::Direct("    the Free Software Foundation; either version 2 of the License, or");
  Msg::Direct("    (at your option) any later version.");
  Msg::Direct(" ");
  Msg::Direct("    This program is distributed in the hope that it will be useful,");
  Msg::Direct("    but WITHOUT ANY WARRANTY; without even the implied warranty of");
  Msg::Direct("    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the");
  Msg::Direct("    GNU General Public License for more details.");
  Msg::Direct(" ");
  Msg::Direct("    You should have received a copy of the GNU General Public License");
  Msg::Direct("    along with this program; if not, write to the Free Software");
  Msg::Direct("    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA");
  Msg::Direct(" ");
  Msg::Direct(" ");
  Msg::Direct("Also add information on how to contact you by electronic and paper mail.");
  Msg::Direct(" ");
  Msg::Direct("If the program is interactive, make it output a short notice like this");
  Msg::Direct("when it starts in an interactive mode:");
  Msg::Direct(" ");
  Msg::Direct("    Gnomovision version 69, Copyright (C) year name of author");
  Msg::Direct("    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.");
  Msg::Direct("    This is free software, and you are welcome to redistribute it");
  Msg::Direct("    under certain conditions; type `show c' for details.");
  Msg::Direct(" ");
  Msg::Direct("The hypothetical commands `show w' and `show c' should show the appropriate");
  Msg::Direct("parts of the General Public License.  Of course, the commands you use may");
  Msg::Direct("be called something other than `show w' and `show c'; they could even be");
  Msg::Direct("mouse-clicks or menu items--whatever suits your program.");
  Msg::Direct(" ");
  Msg::Direct("You should also get your employer (if you work as a programmer) or your");
  Msg::Direct("school, if any, to sign a \"copyright disclaimer\" for the program, if");
  Msg::Direct("necessary.  Here is a sample; alter the names:");
  Msg::Direct(" ");
  Msg::Direct("  Yoyodyne, Inc., hereby disclaims all copyright interest in the program");
  Msg::Direct("  `Gnomovision' (which makes passes at compilers) written by James Hacker.");
  Msg::Direct(" ");
  Msg::Direct("  <signature of Ty Coon>, 1 April 1989");
  Msg::Direct("  Ty Coon, President of Vice");
  Msg::Direct(" ");
  Msg::Direct("This General Public License does not permit incorporating your program into");
  Msg::Direct("proprietary programs.  If your program is a subroutine library, you may");
  Msg::Direct("consider it more useful to permit linking proprietary applications with the");
  Msg::Direct("library.  If this is what you want to do, use the GNU Library General");
  Msg::Direct("Public License instead of this License.");
}
